package adproject;

import java.util.Arrays;

public class WoodCutter {

    private int n;
    private boolean p[];
    private int length;
    private int[] cutPoints;
    private int[] result;
    private int[] cost;
    private int resultIndex = 0;
    private int counter = 0;

    private int cutter(int[] points, int start, int indexStart, int end, int indexEnd) {
        counter++;
        if (this.n == 0) {
            return 0;
        }
        float mid = (float) (start + end) / 2;
        float j = Math.abs(mid - points[indexStart]);

        int cutPoint = points[indexStart];
        int indexCutPoint = indexStart;
        for (int i = indexStart + 1; i <= indexEnd; i++) {

            float t = Math.abs(mid - points[i]);
            if (t < j) {
                j = t;
                cutPoint = points[i];
                indexCutPoint = i;
            }

        }
        if (p[indexCutPoint]) {
            return 0;
        }
        p[indexCutPoint] = true;

        addResult(cutPoint, end - start);

        this.n--;

        return cutter(points, start, indexStart, cutPoint, indexCutPoint)
                + cutter(points, cutPoint, indexCutPoint, end, indexEnd) + (end - start);

    }

    public int getLength() {
        return length;
    }

    public void setLength(int length) {
        this.length = length;
    }

    public int[] getCutPoints() {
        return result;
    }

    public int[] getCost() {
        return cost;
    }

    public int getCounter() {
        return counter;
    }

    private void addResult(int cutpoint, int cost) {
        this.result[resultIndex] = cutpoint;
        this.cost[resultIndex] = cost;
        this.resultIndex++;
    }

    public void setCutPoints(int[] cutPoints) {
        Arrays.sort(cutPoints);
        this.cutPoints = cutPoints;
        this.n = cutPoints.length;
        this.result = new int[cutPoints.length];
        this.cost = new int[cutPoints.length];
        this.p = new boolean[cutPoints.length];
    }

    public int cutter() {
        counter = 0;
        return cutter(cutPoints, 0, 0, length, cutPoints.length - 1);
    }
//    public static void main(String[] args) {
//
//        WoodCutter a = new WoodCutter();
//        a.setLength(20);
//        a.setCutPoints(2, 5, 8, 11);
//        int O = a.cutter();
//        System.out.println(O);
//    }
}
